Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/AverageTrade.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/AverageTrade.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/AverageTrade.cs	(revision 9262)
@@ -0,0 +1,37 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    [StorableClass]
+    [Item("Average", "Symbol that represents the average (arithmetic mean) function.")]
+    public class AverageTrade : Symbol
+    {
+        private const int minimumArity = 1;
+        private const int maximumArity = 1;
+
+        public override int MinimumArity
+        {
+            get { return minimumArity; }
+        }
+        public override int MaximumArity
+        {
+            get { return maximumArity; }
+        }
+
+        [StorableConstructor]
+        private AverageTrade(bool deserializing) : base(deserializing) { }
+        private AverageTrade(AverageTrade original, Cloner cloner) : base(original, cloner) { }
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new AverageTrade(this, cloner);
+        }
+        public AverageTrade() : base("AverageTrade", "Symbol that represents the average (arithmetic mean) function.") { }
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/BoolConstant.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/BoolConstant.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/BoolConstant.cs	(revision 9262)
@@ -0,0 +1,50 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    [StorableClass]
+    [Item("BoolConstant", "Represents a BoolConstant value.")]
+    public sealed class BoolConstant : Symbol
+    {
+        private const int minimumArity = 0;
+        private const int maximumArity = 0;
+
+        public override int MinimumArity
+        {
+            get { return minimumArity; }
+        }
+        public override int MaximumArity
+        {
+            get { return maximumArity; }
+        }
+
+
+        [StorableConstructor]
+        private BoolConstant(bool deserializing) : base(deserializing) { }
+        private BoolConstant(BoolConstant original, Cloner cloner)
+            : base(original, cloner)
+        {
+        }
+        public BoolConstant()
+            : base("BoolConstant", "Represents a BoolConstant value.")
+        {
+        }
+
+        public override ISymbolicExpressionTreeNode CreateTreeNode()
+        {
+            return new BoolConstantTreeNode(this);
+        }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new BoolConstant(this, cloner);
+        }
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/BoolConstantTreeNode.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/BoolConstantTreeNode.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/BoolConstantTreeNode.cs	(revision 9262)
@@ -0,0 +1,59 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    [StorableClass]
+    public sealed class BoolConstantTreeNode : SymbolicExpressionTreeTerminalNode
+    {
+
+      public new BoolConstant Symbol {
+      get { return (BoolConstant)base.Symbol; }
+    }
+
+    private double BoolConstantValue;
+    [Storable]
+    public double Value {
+      get { return BoolConstantValue; }
+      set { BoolConstantValue = value; }
+    }
+
+    [StorableConstructor]
+    private BoolConstantTreeNode(bool deserializing) : base(deserializing) { }
+
+    private BoolConstantTreeNode(BoolConstantTreeNode original, Cloner cloner)
+      : base(original, cloner) {
+      BoolConstantValue = original.BoolConstantValue;
+    }
+
+    private BoolConstantTreeNode() : base() { }
+    public BoolConstantTreeNode(BoolConstant BoolConstantSymbol) : base(BoolConstantSymbol) { }
+
+    public override bool HasLocalParameters {
+      get {
+        return true;
+      }
+    }
+    public override void ResetLocalParameters(IRandom random) {
+      base.ResetLocalParameters(random);
+      if (random.Next(1) == 0) Value = -1;
+      else Value = 1;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new BoolConstantTreeNode(this, cloner);
+    }
+
+    public override string ToString() {
+      return BoolConstantValue.ToString("E5");
+    }
+  }
+}
+
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/ConstantInt.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/ConstantInt.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/ConstantInt.cs	(revision 9262)
@@ -0,0 +1,50 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    [StorableClass]
+    [Item("ConstantInt", "Represents a ConstantInt value.")]
+    public sealed class ConstantInt : Symbol
+    {
+        private const int minimumArity = 0;
+        private const int maximumArity = 0;
+
+        public override int MinimumArity
+        {
+            get { return minimumArity; }
+        }
+        public override int MaximumArity
+        {
+            get { return maximumArity; }
+        }
+
+
+        [StorableConstructor]
+        private ConstantInt(bool deserializing) : base(deserializing) { }
+        private ConstantInt(ConstantInt original, Cloner cloner)
+            : base(original, cloner)
+        {
+        }
+        public ConstantInt()
+            : base("ConstantInt", "Represents a ConstantInt value.")
+        {
+        }
+
+        public override ISymbolicExpressionTreeNode CreateTreeNode()
+        {
+            return new ConstantIntTreeNode(this);
+        }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new ConstantInt(this, cloner);
+        }
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/ConstantIntTreeNode.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/ConstantIntTreeNode.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/ConstantIntTreeNode.cs	(revision 9262)
@@ -0,0 +1,66 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    [StorableClass]
+    public sealed class ConstantIntTreeNode : SymbolicExpressionTreeTerminalNode
+    {
+
+        public new ConstantInt Symbol
+        {
+            get { return (ConstantInt)base.Symbol; }
+        }
+
+        private double ConstantIntValue;
+        [Storable]
+        public double Value
+        {
+            get { return ConstantIntValue; }
+            set { ConstantIntValue = value; }
+        }
+
+        [StorableConstructor]
+        private ConstantIntTreeNode(bool deserializing) : base(deserializing) { }
+
+        private ConstantIntTreeNode(ConstantIntTreeNode original, Cloner cloner)
+            : base(original, cloner)
+        {
+            ConstantIntValue = original.ConstantIntValue;
+        }
+
+        private ConstantIntTreeNode() : base() { }
+        public ConstantIntTreeNode(ConstantInt ConstantIntSymbol) : base(ConstantIntSymbol) { }
+
+        public override bool HasLocalParameters
+        {
+            get
+            {
+                return true;
+            }
+        }
+        public override void ResetLocalParameters(IRandom random)
+        {
+            base.ResetLocalParameters(random);
+            
+            Value = random.Next(25)+1;
+        }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new ConstantIntTreeNode(this, cloner);
+        }
+
+        public override string ToString()
+        {
+            return ConstantIntValue.ToString("E5");
+        }
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/ITradeRulesExpresionTree.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/ITradeRulesExpresionTree.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/ITradeRulesExpresionTree.cs	(revision 9262)
@@ -0,0 +1,17 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    public interface ITradeRulesExpresionTree : ISymbolicDataAnalysisExpressionTreeInterpreter
+    {
+         void setInitialTraining(int initialTraining);
+         void setInitialTest(int initialTest);
+         void clearVariables();
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/Lag.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/Lag.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/Lag.cs	(revision 9262)
@@ -0,0 +1,34 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    class Lag : Symbol
+    {
+        private const int minimumArity = 1;
+        private const int maximumArity = 1;
+
+        public override int MinimumArity
+        {
+            get { return minimumArity; }
+        }
+        public override int MaximumArity
+        {
+            get { return maximumArity; }
+        }
+
+        [StorableConstructor]
+        private Lag(bool deserializing) : base(deserializing) { }
+        private Lag(Lag original, Cloner cloner) : base(original, cloner) { }
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new Lag(this, cloner);
+        }
+        public Lag() : base("Lag", "Symbol that represents the Lag value in a time") { }
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/MACD.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/MACD.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/MACD.cs	(revision 9262)
@@ -0,0 +1,52 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.TradeRules.Symbols;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    [StorableClass]
+    [Item("MACD", "Symbol that represents the MACD indicator.")]
+    public sealed class MACD : Symbol
+    {
+        private const int minimumArity = 3;
+        private const int maximumArity = 3;
+
+        public override int MinimumArity
+        {
+            get { return minimumArity; }
+        }
+        public override int MaximumArity
+        {
+            get { return maximumArity; }
+        }
+
+       [StorableConstructor]
+        private MACD(bool deserializing) : base(deserializing) { }
+        private MACD(MACD original, Cloner cloner)
+            : base(original, cloner)
+        {
+        }
+        public MACD()
+            : base("MACD", "Represents a MACD indicator.")
+        {
+        }
+
+        public override ISymbolicExpressionTreeNode CreateTreeNode()
+        {
+            return new MACDTreeNode(this);
+        }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new MACD(this, cloner);
+        }
+
+
+    }
+ }
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/MACDTreeNode.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/MACDTreeNode.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/MACDTreeNode.cs	(revision 9262)
@@ -0,0 +1,38 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Problems.TradeRules.Symbols
+{
+    public sealed class  MACDTreeNode : SymbolicExpressionTreeNode
+    {
+      public new MACD Symbol {
+      get { return (MACD)base.Symbol;}
+    }
+
+    [StorableConstructor]
+    private MACDTreeNode(bool deserializing) : base(deserializing) { }
+
+    private MACDTreeNode(MACDTreeNode original, Cloner cloner)
+      : base(original, cloner) {
+      
+    }
+
+    public MACDTreeNode(MACD MACDSymbol) : base(MACDSymbol) { }
+
+    public override bool HasLocalParameters {
+      get {
+        return true;
+      }
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MACDTreeNode(this, cloner);
+    }
+
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/Max.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/Max.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/Max.cs	(revision 9262)
@@ -0,0 +1,35 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    class Max :Symbol
+    {
+        private const int minimumArity = 1;
+        private const int maximumArity = 1;
+
+        public override int MinimumArity
+        {
+            get { return minimumArity; }
+        }
+        public override int MaximumArity
+        {
+            get { return maximumArity; }
+        }
+
+        [StorableConstructor]
+        private Max(bool deserializing) : base(deserializing) { }
+        private Max(Max original, Cloner cloner) : base(original, cloner) { }
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new Max(this, cloner);
+        }
+        public Max() : base("Max", "Symbol that represents the Max value in a time") { }
+    }
+ }
+
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/Min.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/Min.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/Min.cs	(revision 9262)
@@ -0,0 +1,34 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    class Min : Symbol
+    {
+        private const int minimumArity = 1;
+        private const int maximumArity = 1;
+
+        public override int MinimumArity
+        {
+            get { return minimumArity; }
+        }
+        public override int MaximumArity
+        {
+            get { return maximumArity; }
+        }
+
+        [StorableConstructor]
+        private Min(bool deserializing) : base(deserializing) { }
+        private Min(Min original, Cloner cloner) : base(original, cloner) { }
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new Min(this, cloner);
+        }
+        public Min() : base("Min", "Symbol that represents the Min value in a time") { }
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/RSI.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/RSI.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Symbols/RSI.cs	(revision 9262)
@@ -0,0 +1,35 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    class RSI: Symbol
+    {
+        private const int minimumArity = 1;
+        private const int maximumArity = 1;
+
+        public override int MinimumArity
+        {
+            get { return minimumArity; }
+        }
+        public override int MaximumArity
+        {
+            get { return maximumArity; }
+        }
+
+        [StorableConstructor]
+        private RSI(bool deserializing) : base(deserializing) { }
+        private RSI(RSI original, Cloner cloner) : base(original, cloner) { }
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new RSI(this, cloner);
+        }
+        public RSI() : base("RSI", "Symbol that represents the RSI indicator.") { }
+    
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/TradeRulesSingleObjectiveTrainingBestSolutionAnalyzer.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/TradeRulesSingleObjectiveTrainingBestSolutionAnalyzer.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/TradeRulesSingleObjectiveTrainingBestSolutionAnalyzer.cs	(revision 9262)
@@ -0,0 +1,69 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Parameters;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    [Item("TradeRulesSingleObjectiveTrainingBestSolutionAnalyzer", "An operator that analyzes the training best symbolic regression solution for single objective symbolic regression problems.")]
+    [StorableClass]
+    public sealed class TradeRulesSingleObjectiveTrainingBestSolutionAnalyzer : SymbolicDataAnalysisSingleObjectiveTrainingBestSolutionAnalyzer<ISymbolicRegressionSolution>,
+  ISymbolicDataAnalysisInterpreterOperator, ISymbolicDataAnalysisBoundedOperator 
+    {
+        private const string ProblemDataParameterName = "ProblemData";
+    private const string SymbolicDataAnalysisTreeInterpreterParameterName = "SymbolicDataAnalysisTreeInterpreter";
+    private const string EstimationLimitsParameterName = "EstimationLimits";
+    private const string ApplyLinearScalingParameterName = "ApplyLinearScaling";
+    #region parameter properties
+    public ILookupParameter<IRegressionProblemData> ProblemDataParameter {
+      get { return (ILookupParameter<IRegressionProblemData>)Parameters[ProblemDataParameterName]; }
+    }
+    public ILookupParameter<ISymbolicDataAnalysisExpressionTreeInterpreter> SymbolicDataAnalysisTreeInterpreterParameter {
+      get { return (ILookupParameter<ISymbolicDataAnalysisExpressionTreeInterpreter>)Parameters[SymbolicDataAnalysisTreeInterpreterParameterName]; }
+    }
+    public IValueLookupParameter<DoubleLimit> EstimationLimitsParameter {
+      get { return (IValueLookupParameter<DoubleLimit>)Parameters[EstimationLimitsParameterName]; }
+    }
+    public IValueParameter<BoolValue> ApplyLinearScalingParameter {
+      get { return (IValueParameter<BoolValue>)Parameters[ApplyLinearScalingParameterName]; }
+    }
+    #endregion
+
+    #region properties
+    public BoolValue ApplyLinearScaling {
+      get { return ApplyLinearScalingParameter.Value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private TradeRulesSingleObjectiveTrainingBestSolutionAnalyzer(bool deserializing) : base(deserializing) { }
+    private TradeRulesSingleObjectiveTrainingBestSolutionAnalyzer(TradeRulesSingleObjectiveTrainingBestSolutionAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    public TradeRulesSingleObjectiveTrainingBestSolutionAnalyzer()
+      : base() {
+      Parameters.Add(new LookupParameter<IRegressionProblemData>(ProblemDataParameterName, "The problem data for the symbolic regression solution."));
+      Parameters.Add(new LookupParameter<ISymbolicDataAnalysisExpressionTreeInterpreter>(SymbolicDataAnalysisTreeInterpreterParameterName, "The symbolic data analysis tree interpreter for the symbolic expression tree."));
+      Parameters.Add(new ValueLookupParameter<DoubleLimit>(EstimationLimitsParameterName, "The lower and upper limit for the estimated values produced by the symbolic regression model."));
+      Parameters.Add(new ValueParameter<BoolValue>(ApplyLinearScalingParameterName, "Flag that indicates if the produced symbolic regression solution should be linearly scaled.", new BoolValue(false)));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TradeRulesSingleObjectiveTrainingBestSolutionAnalyzer(this, cloner);
+    }
+
+    protected override ISymbolicRegressionSolution CreateSolution(ISymbolicExpressionTree bestTree, double bestQuality) {
+      var model = new SymbolicRegressionModel((ISymbolicExpressionTree)bestTree.Clone(), SymbolicDataAnalysisTreeInterpreterParameter.ActualValue, EstimationLimitsParameter.ActualValue.Lower, EstimationLimitsParameter.ActualValue.Upper);
+      if (ApplyLinearScaling.Value)
+          SymbolicRegressionModel.Scale(model, ProblemDataParameter.ActualValue);
+      return new TradingRulesSolution(model, (IRegressionProblemData)ProblemDataParameter.ActualValue.Clone());
+    }
+  }
+    }
+
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/TradeRulesSingleObjectiveValidationBestSolutionAnalyzer.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/TradeRulesSingleObjectiveValidationBestSolutionAnalyzer.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/TradeRulesSingleObjectiveValidationBestSolutionAnalyzer.cs	(revision 9262)
@@ -0,0 +1,61 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Common;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    [Item("TradeRulesSingleObjectiveValidationBestSolutionAnalyzer", "An operator that analyzes the validation best symbolic regression solution for single objective symbolic regression problems.")]
+    [StorableClass]
+    public sealed class TradeRulesSingleObjectiveValidationBestSolutionAnalyzer : SymbolicDataAnalysisSingleObjectiveValidationBestSolutionAnalyzer<ISymbolicRegressionSolution, ISymbolicRegressionSingleObjectiveEvaluator, IRegressionProblemData>,
+    ISymbolicDataAnalysisBoundedOperator
+    {
+         private const string EstimationLimitsParameterName = "EstimationLimits";
+    private const string ApplyLinearScalingParameterName = "ApplyLinearScaling";
+
+    #region parameter properties
+    public IValueLookupParameter<DoubleLimit> EstimationLimitsParameter {
+      get { return (IValueLookupParameter<DoubleLimit>)Parameters[EstimationLimitsParameterName]; }
+    }
+    public IValueParameter<BoolValue> ApplyLinearScalingParameter {
+      get { return (IValueParameter<BoolValue>)Parameters[ApplyLinearScalingParameterName]; }
+    }
+    #endregion
+
+    #region properties
+    public BoolValue ApplyLinearScaling {
+      get { return ApplyLinearScalingParameter.Value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private TradeRulesSingleObjectiveValidationBestSolutionAnalyzer(bool deserializing) : base(deserializing) { }
+    private TradeRulesSingleObjectiveValidationBestSolutionAnalyzer(TradeRulesSingleObjectiveValidationBestSolutionAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    public TradeRulesSingleObjectiveValidationBestSolutionAnalyzer()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<DoubleLimit>(EstimationLimitsParameterName, "The lower and upper limit for the estimated values produced by the symbolic regression model."));
+      Parameters.Add(new ValueParameter<BoolValue>(ApplyLinearScalingParameterName, "Flag that indicates if the produced symbolic regression solution should be linearly scaled.", new BoolValue(false)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+        return new TradeRulesSingleObjectiveValidationBestSolutionAnalyzer(this, cloner);
+    }
+
+    protected override ISymbolicRegressionSolution CreateSolution(ISymbolicExpressionTree bestTree, double bestQuality) {
+      var model = new SymbolicRegressionModel((ISymbolicExpressionTree)bestTree.Clone(), SymbolicDataAnalysisTreeInterpreterParameter.ActualValue, EstimationLimitsParameter.ActualValue.Lower, EstimationLimitsParameter.ActualValue.Upper);
+      if (ApplyLinearScaling.Value)
+        SymbolicRegressionModel.Scale(model, ProblemDataParameter.ActualValue);
+      return new TradingRulesSolution(model, (IRegressionProblemData)ProblemDataParameter.ActualValue.Clone());
+    }
+
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/TradeSolution.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/TradeSolution.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/TradeSolution.cs	(revision 9262)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    class TradeSolution
+    {
+    }
+}
